/*
 *	main.c
 *
 *	ɂ` AGAINST(ڐA)
 *
 *	* Tue Jan 30 23:36:15 JST 2007 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SOUND
const void* sound_table[SOUND_COUNT];
#endif /*USE_SOUND*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef RESOURCE_FNAME
	/* pext@CYt\[X擾܂B */
	resource = resource_address(RESOURCE_FNAME);
#endif /*RESOURCE_FNAME*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

#ifdef USE_2BIT_ADPCM
	/* 2-bit ADPCM DecoderN܂B */
	adpcm_init(ADPCM_CHANNELS);
#endif /*USE_2BIT_ADPCM*/

	/* TEh܂B */
#ifdef USE_SOUND
	{
#define SOUND_(name) { extern const unsigned char name[]; sound_table[SND_##name] = name; }
#define SOUND_RESOURCE_(name,fname) { sound_table[SND_##name] = fpk_address(resource, fname, NULL); }
#include "sound.h"
#undef SOUND_
#undef SOUND_RESOURCE_
	}
#endif /*USE_SOUND*/

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#define TEXTURE_RESOURCE_(name,fname) const void* const name = fpk_address(resource, fname, NULL);
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#define TEXTURE_RESOURCE_(name,fname) name,
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	update
 ****************************************************************************/

/* * Mon Nov 06 17:37:17 JST 2006 Naoyuki Sawa
 * - schedule()AʍXV𕪗܂B
 *   t[҂ʍXVsꍇ́Å֐ĂяoĂB
 */
void
update()
{
#ifdef V_SCREEN
	/* vbuff(c)_def_vbuff()ϊ */
	unsigned char *dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
	unsigned char *src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
	int x, y;
	for(x = DISP_X - 1; x >= 0; x--) {
		for(y = 0; y < DISP_Y; y++) {
			*dst = *src;
			dst += 1;      /* ʂEɑ܂ */
			src += DISP_X; /* cʂɑ܂ */
		}
		                            /* ʂ͊Ɏ̍sֈړĂ܂ */
		src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
	}
#endif /*V_SCREEN*/

	/* ʓ] */
	pceLCDTrans();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

/* * Fri Dec 15 00:49:15 JST 2006 Naoyuki Sawa
 * - schedule()֐ɁATEh|[YΉR[hǉ܂B
 *   ł͏肭삵Ă悤łAX[v̕Aɖ肪NȂmFłB
 * - A|[YԂ̂܂܁AȂ킿ATEh|[YԂ̂܂܂ŃAvP[VIĂ܂ꍇɂA
 *   CLiPCupceAppExit()pceWaveStop(1)ĂяoĂATEhԂZbĝŁAvłB
 */

void
schedule()
{
#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		/*{{2006/12/15:TEh|[YΉ*/
		int sound_pause = 0/*x}*/;
		/*}}2006/12/15:TEh|[YΉ*/
		int x, y;
		for(;;) {
#endif /*USE_PAUSE*/
			update();		/* ʍXV */
			yield();		/* VXe */
			joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					sound_pause = fINT_EDMA.EHDM1;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 0;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 1;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

// JڏԃXe[g
#define STATE_TITLE_INIT	0
#define STATE_TITLE		1
#define STATE_GAME_INIT		2
#define STATE_GAME		3
#define STATE_OVER_INIT		4
#define STATE_OVER		5

// VXe萔
#define BULLETTIME		96	// obg^C臒l

// G֘A
#define ENEMY_TYPE_SHOT1	1	// e
#define ENEMY_TYPE_SHOT2	2	// jW
#define ENEMY_TYPE_SHOT3	3	// |bL[
#define ENEMY_TYPE_SHOT4	4	// 卪
#define ENEMY_TYPE_ZAKO1	5	// Ȃ
#define ENEMY_TYPE_ZAKO2	6	// Ă
#define ENEMY_TYPE_BOX1		7	// 5
#define ENEMY_TYPE_BOX2		8	// X
#define ENEMY_TYPE_MID1		9	// 
#define ENEMY_TYPE_MID2		10	// v

// @֘A
#define MYCHAR_SPEED1		5.0	// ʏړx
#define MYCHAR_SPEED2		0.2	// ᑬړx
#define MYCHAR_SPWEAKEN		0.5	// 
#define MYCHAR_REACTWEAKEN	0.85	// 
#define MYCHAR_ROT		0.06	// (LG)x
#define MYCHAR_ROTWEAKEN	0.80	// (LG)񌸐
#define MYCHAR_SIZE		24.0	// TCY
#define MYCHAR_DAM_SP		3.0	// _[W̔(x)
#define MYCHAR_DAM_TIME		25	// _[W̃_[Wy
#define MYCHAR_DAMAGE		0.1	// _[WyԒ̃_[Wy
#define MYCHAR_LIFE_MAX		1300	// ő僉Ct
#define MYCHAR_LIFE_BRINK	600	// Ct_ł臒l

// AJ[/͂/֘A
#define ANCHOR_ROT_SP		0.15	// 񑬓x
#define ANCHOR_SHOT_SP		16.0	// ˏox
#define ANCHOR_SHOT_CONTROL	0.5	// ˏoԂ̕␳(x)
#define ANCHOR_REACT_FORCE	0.5	// ˏo̔
#define ANCHOR_RETURN_SP	16.0	// x
#define ANCHOR_GRAB_SP		1.6	// ͂ݎ̃AJ[x
#define ANCHOR_GRAB_SPWEAKEN	0.9	// ͂ݎ̃AJ[x
#define ANCHOR_THROW_SP		8.0	// ̓Gx
#define ANCHOR_CHAIN_NUM	8	// `F[̐
#define ANCHOR_SIZE		24.0	// TCY
#define ANCHOR_LENGTH_LIMIT	240.0	// 
#define THROWN_DROP_SP		0.1	// Gɂd͉x
#define THROWN_HIT_WEAKEN	0.9	// GqbgƂ̑x
#define GRAB_HIT_WEAKEN		0.1	// ͂ݓGGɃqbgƂ̑x
#define CATCHABLE_BORDER	10	// ͂݉\ȓG̃Ct臒l(ɉēGXRA֗^)

// AJ[Jڏ
#define ANCHOR_STATE_STANDBY	1
#define ANCHOR_STATE_THROW	2
#define ANCHOR_STATE_GRAB	3
#define ANCHOR_STATE_RETURN	4

// GtFNg֘A
#define EFFECT_TYPE_PERTIC1	1
#define EFFECT_TYPE_PERTIC2	2
#define EFFECT_TYPE_RING	3
#define EFFECT_TYPE_LINE	4
#define EFFECT_TYPE_BANANA	5
#define EFFECT_LIVETIME		30	// GtFNg
#define EFFECT_SPWEAKEN		0.9	// GtFNgx

#define ENEMYGENE_NONECRASH	240.0	// G̏Փˉ

// GXybN
typedef struct _ENEMY_SPEC {
	float size;
	int life;
	int dam;
	int score;
} ENEMY_SPEC;
const ENEMY_SPEC enemy_spec[] = {
	{  0.0,  0,   0,  0 },	// (gp)
	{  8.0,  0, 300,  0 },	// e
	{ 16.0,  5, 500,  1 },	// jW
	{  8.0,  0, 300,  0 },	// |bL[
	{ 16.0,  5, 500,  1 },	// 卪
	{ 24.0,  5, 600, 10 },	// Ȃ
	{ 24.0,  5, 600, 10 },	// Ă
	{ 24.0, 15, 600,  0 },	// 5
	{ 48.0, 40, 600,  0 },	// X
	{ 48.0, 30, 600, 50 },	// 
	{ 48.0, 30, 600, 80 },	// v
};

typedef struct _MYCHAR {
	float x;
	float y;
	float sx;
	float sy;
	float ssx;
	float ssy;
	float gr_rotate;
	float anc_rotate;
	int dam_timer;
	int life;
} MYCHAR;
MYCHAR mychar;

typedef struct _ANCHOR {
	float x;
	float y;
	float sx;
	float sy;
	float rotate;
	int state;
} ANCHOR;
ANCHOR anchor;

typedef struct _GRAB_ENEMY {
	int type;
	float rotate;
	float x;
	float y;
	int life;
} GRAB_ENEMY;
GRAB_ENEMY grab_enemy;

typedef struct _ENEMY {
	LIST_ENTRY list_entry;
	int type;	// G^Cv
	float x;	// Wx
	float y;	//     y
	float sx;	// xx
	float sy;	//     y
	float rotate;	// 
	int life;	// Ct
	int flag;	// tO(eGɂĎgp@͂܂)
	int timer;	// ^C}[
} ENEMY;
POOL enemy_pool = { sizeof(ENEMY) };
LIST_ENTRY enemy_list = { &enemy_list, &enemy_list };
#define REPEAT_ENEMY() {								\
	LIST_ENTRY* __list_entry__ = enemy_list.Flink;					\
	while(__list_entry__ != &enemy_list) {						\
		ENEMY* enemy = CONTAINING_RECORD(__list_entry__, ENEMY, list_entry);	\
		__list_entry__ = __list_entry__->Flink;
#define LOOP_ENEMY() } }

typedef struct _THRENEMY {
	LIST_ENTRY list_entry;
	int type;	// G^Cv
	float x;
	float y;
	float sx;
	float sy;
	float rotate;
	int life;
} THRENEMY;
POOL threnemy_pool = { sizeof(THRENEMY) };
LIST_ENTRY threnemy_list = { &threnemy_list, &threnemy_list };
#define REPEAT_THRENEMY() {									\
	LIST_ENTRY* __list_entry__ = threnemy_list.Flink;					\
	while(__list_entry__ != &threnemy_list) {						\
		THRENEMY* threnemy = CONTAINING_RECORD(__list_entry__, THRENEMY, list_entry);	\
		__list_entry__ = __list_entry__->Flink;
#define LOOP_THRENEMY() } }

typedef struct _EFFECT {
	LIST_ENTRY list_entry;
	int type;	// GtFNg^Cv
	float x;
	float y;
	float sx;
	float sy;
	float rotate;
	float size;
	int timer;
} EFFECT;
POOL effect_pool = { sizeof(EFFECT) };
LIST_ENTRY effect_list = { &effect_list, &effect_list };
#define REPEAT_EFFECT() {								\
	LIST_ENTRY* __list_entry__ = effect_list.Flink;					\
	while(__list_entry__ != &effect_list) {						\
		EFFECT* effect = CONTAINING_RECORD(__list_entry__, EFFECT, list_entry);	\
		__list_entry__ = __list_entry__->Flink;
#define LOOP_EFFECT() } }

int state;

int level;
//int levelmax;
//P/ECEłł͍ŏ1010Ԓn܂őI\ɂ܂B
int levelmax = 99;
int score;
int hiscore;
int banana_score;
int banana_hiscore;

int play_timer;
int over_timer;

void mainloop();
void statetitleinit();
void statetitle();
void stategameinit();
void stategame();
void stateoverinit();
void stateover();

void addenemy(float xx, float yy, float sxx, float syy, float rot, int tp);
void delenemy(ENEMY* enemy);
void addthrenemy(float xx, float yy, float sxx, float syy, float rrr, int tp, int lf);
void delthrenemy(THRENEMY* threnemy);
void addeffect(float xx, float yy, float sxx, float syy, float rrr, float szz, int tp);
void deleffect(EFFECT* effect);
void addpertics(float xx, float yy, float spp, float szz, float sxx, float syy, int numm);
void destroypertics(float xx, float yy, float sxx, float syy, int tp);
void addscore(int sscore);

void drawback();
void drawstatus();
void debugstatus();

void movemychar();
void moveanchor();
void moveenemy();
void collisionenemy();
void geneenemy();
void fdrawenemy(float xx, float yy, float rot, int tp);
void drawmychar();
void drawchain();
void drawenemy();
void drawbanana();
void movedraweffect();

unsigned char bgbuff[DISP_X * DISP_Y];

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	sprite_draw(0, 0, SPR_BG, DRW_NOMAL);
	memcpy(bgbuff, vbuff, DISP_X * DISP_Y);

	stategameinit();
	state = STATE_TITLE_INIT;
	mainloop();
}

int
rnd(int n)
{
	return RND32_RANGE(seed, 0, n);
}

void
ds_play(int no)
{
	sound_play(no, sound_table[no], 1);
}

void
gcopy(int spr, float x, float y)
{
	x *= (128.0 / 640.0);
	y *= ( 88.0 / 480.0);

	sprite_draw(x, y, spr, DRW_NOMAL);
}

void
grotate(int spr, float x, float y, float r)
{
	int i;

	x *= (128.0 / 640.0);
	y *= ( 88.0 / 480.0);

	i = (r + (M_PI2 / 32 / 2)) * (32 / M_PI2);
	while(i <   0) i += 32;
	while(i >= 32) i -= 32;
	spr += i;

	sprite_draw(x, y, spr, DRW_NOMAL);
}

/****************************************************************************
 *	mainloop
 ****************************************************************************/

void
mainloop()
{
	int debug = 0;

	for(;;) {
		schedule();

		// BR}hA\tgEGAZbgAI
		if(joy & TRG_SELECT) {
			if(joy & PAD_A) {
				mychar.life = MYCHAR_LIFE_MAX; // A+SEL:CtS(BR}h)
			} else if(joy & PAD_B) {
				debug = !debug; // B+SEL:fobO[hؑ(BR}h)
			} else {
				if(state != STATE_TITLE) {
					state = STATE_TITLE_INIT; // Q[SEL:\tgEFAZbg
				} else {
					break; // ^CgʂSEL:I
				}
			}
		}

		// eԂs
		drawback();
		switch(state) {
		case STATE_TITLE_INIT: statetitleinit(); break;
		case STATE_TITLE:      statetitle();     break;
		case STATE_GAME_INIT:  stategameinit();  break;
		case STATE_GAME:       stategame();      break;
		case STATE_OVER_INIT:  stateoverinit();  break;
		case STATE_OVER:       stateover();      break;
		}
		drawstatus();
		if(debug) debugstatus(); // fobOp

		//{{---
		// t[
		//int t = list_size((LIST*)&enemy_list); // G̑
		//REPEAT_EFFECT()
		//	if(effect->type == EFFECT_TYPE_BANANA) {
		//		t += 2; // ΂Ȃx2
		//	}
		//LOOP_EFFECT()
		//// (G̑)(΂Ȃx2)臒lz邩A~Xƃobg^C
		//if((state == STATE_GAME) &&
		//   ((t > BULLETTIME) || mychar.dam_timer)) {
		//	// obg^C
		//} else {
		//	// ʏ
		//}
		//IWił́Â悤ȏ30fps->20fps̃X[Ă܂A
		//P/ECE͂Gƕ`悪Ԃɍ킸X[ɂȂĂ܂܂B
		//ŒPɁA~X30fps->15fps̃X[邱Ƃɂ܂B
		if((state == STATE_GAME) && mychar.dam_timer) {
			yield();
		}
		//}}---
	}
}

/****************************************************************************
 *	statetitleinit
 ****************************************************************************/

void
statetitleinit()
{
	state = STATE_TITLE;

	play_timer = 0;
	level = 0;
}

/****************************************************************************
 *	statetitle
 ****************************************************************************/

void
statetitle()
{
	int retval;
	int i;
	int color;
	int param;
	int x;
	int y;
	int spr;

	x = 64 - 30;
	y = 36 - 10;
	sprite_draw(x, y, SPR_TITLE, DRW_NOMAL);

	for(i = 0; i < 2; i++) {
		color = i ? 2 : 1;
		param = DRW_CLR(color, COLOR_MASK);

		x = 35 - i;
		y = 50 - i;

		/* `ƏZ */
		spr = SPR_STARTJYUSHO;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* : */
		retval = render_printf(&render, x, y, 2, color, ":");
		x += LOHALF(retval);

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level / 10 + 1);
		x += LOHALF(retval);

		/*  */
		spr = SPR_CHOME;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level % 10 + 1);
		x += LOHALF(retval);

		/* Ԓn */
		spr = SPR_BANTI;
		sprite_draw(x, y, spr, param);
	}

	if(play_timer > 1) {
		// Jnx
		if(joy & TRG_LF) level--;
		if(joy & TRG_RI) level++;
		if(joy & TRG_UP) level -= 10;
		if(joy & TRG_DN) level += 10;
		if(level <        0) level =        0;
		if(level > levelmax) level = levelmax;

		// Q[Jn
		if(joy & TRG_A) state = STATE_GAME_INIT;
	}
	play_timer++;
}

/****************************************************************************
 *	stategameinit
 ****************************************************************************/

void
stategameinit()
{
	memset(&mychar, 0, sizeof(MYCHAR));
	mychar.x = 320.0;
	mychar.y = 240.0;
	mychar.life = MYCHAR_LIFE_MAX;

	memset(&anchor, 0, sizeof(ANCHOR));
	anchor.state = ANCHOR_STATE_STANDBY;

	memset(&grab_enemy, 0, sizeof(GRAB_ENEMY));

	REPEAT_ENEMY()
		delenemy(enemy);
	LOOP_ENEMY()
	REPEAT_THRENEMY()
		delthrenemy(threnemy);
	LOOP_THRENEMY()
	REPEAT_EFFECT()
		deleffect(effect);
	LOOP_EFFECT();

	play_timer = 0;
	score = 0;
	banana_score = 0;

	state = STATE_GAME;
}

/****************************************************************************
 *	stategame
 ****************************************************************************/

void
stategame()
{
	play_timer++;

	movemychar();
	moveanchor();
	moveenemy();
	collisionenemy();

	drawbanana();
	drawchain();
	drawenemy();
	movedraweffect();
	drawmychar();

	geneenemy();

	if(!(play_timer % 400)) level++;

	if(score > hiscore) hiscore = score;
	if(banana_score > banana_hiscore) banana_hiscore = banana_score;

	if(mychar.life < 0) state = STATE_OVER_INIT;
}

/****************************************************************************
 *	stateoverinit
 ****************************************************************************/

void
stateoverinit()
{
	state = STATE_OVER;
	over_timer = 0;

	if(level > levelmax) levelmax = level;

	addeffect(
		mychar.x,
		mychar.y,
		0.0,
		0.0,
		rnd(128) / 64.0 * M_PI,
		64.0,
		EFFECT_TYPE_PERTIC1);
	addeffect(
		mychar.x,
		mychar.y,
		0.0,
		0.0,
		rnd(128) / 64.0 * M_PI,
		384.0,
		EFFECT_TYPE_RING);
	addpertics(
		mychar.x,
		mychar.y,
		64.0,
		32.0,
		0.0,
		0.0,
		15);
	ds_play(SND_EXPLODE2);
}

/****************************************************************************
 *	stateover
 ****************************************************************************/

void
stateover()
{
	int retval;
	int i;
	int color;
	int param;
	int x;
	int y;
	int spr;
	int tmp;

	moveenemy();
	collisionenemy();

	drawbanana();
	drawenemy();
	movedraweffect();

	play_timer++;

	over_timer++;
	if(over_timer > 30) {
		if(joy & TRG_A) state = STATE_TITLE_INIT;
	}

	for(i = 0; i < 2; i++) {
		color = i ? 2 : 1;
		param = DRW_CLR(color, COLOR_MASK);

		x = 37 - i;
		y = 36 - i;

		/* `ށ`΁` */
		spr = SPR_GAMEOVER;
		sprite_draw(x, y, spr, param);

		x = 51 - i;
		y = 53 - i;

		tmp = level / 10 + 1; while(tmp >= 10) { tmp /= 10; x -= 2; }
		tmp = level % 10 + 1; while(tmp >= 10) { tmp /= 10; x -= 2; }

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level / 10 + 1);
		x += LOHALF(retval);

		/*  */
		spr = SPR_CHOME;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level % 10 + 1);
		x += LOHALF(retval);

		/* Ԓn */
		spr = SPR_BANTI;
		sprite_draw(x, y, spr, param);

		x = 34 - i;
		y = 59 - i;

		tmp =        score; while(tmp >= 10) { tmp /= 10; x -= 2; }
		tmp = banana_score; while(tmp >= 10) { tmp /= 10; x -= 2; }

		/*  */
		spr = SPR_OYATUDAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", score);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* / */
		retval = render_printf(&render, x, y, 2, color, "/");
		x += LOHALF(retval);

		/* ΂Ȃȑ */
		spr = SPR_BANANADAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", banana_score);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
	}
}

/****************************************************************************
 *	addenemy
 ****************************************************************************/

// ʏGǉ
// xx  - Wx
// yy  - @@y
// sxx - xx
// syy - @@y
// rot - 
// tp  - G^Cv
void
addenemy(float xx, float yy, float sxx, float syy, float rot, int tp)
{
	ENEMY* enemy = pool_alloc(&enemy_pool);
	InsertTailList(&enemy_list, &enemy->list_entry);

	enemy->type = tp;
	enemy->x = xx;
	enemy->y = yy;
	enemy->sx = sxx;
	enemy->sy = syy;
	enemy->rotate = rot;
	enemy->life = enemy_spec[tp].life;
}

/****************************************************************************
 *	delenemy
 ****************************************************************************/

void
delenemy(ENEMY* enemy)
{
	RemoveEntryList(&enemy->list_entry);
	pool_free(enemy);
}

/****************************************************************************
 *	addthrenemy
 ****************************************************************************/

// Gǉ
// xx  - Wx
// yy  - @@y
// sxx - xx
// syy - @@y
// rrr - 
// tp  - G^Cv
// lf  - GCt
void
addthrenemy(float xx, float yy, float sxx, float syy, float rrr, int tp, int lf)
{
	THRENEMY* threnemy = pool_alloc(&threnemy_pool);
	InsertTailList(&threnemy_list, &threnemy->list_entry);

	threnemy->type = tp;
	threnemy->x = xx;
	threnemy->y = yy;
	threnemy->sx = sxx;
	threnemy->sy = syy;
	threnemy->rotate = rrr;
	threnemy->life = lf;
}

/****************************************************************************
 *	delthrenemy
 ****************************************************************************/

void
delthrenemy(THRENEMY* threnemy)
{
	RemoveEntryList(&threnemy->list_entry);
	pool_free(threnemy);
}

/****************************************************************************
 *	addeffect
 ****************************************************************************/

// GtFNgǉ
// xx  - Wx
// yy  - @@y
// sxx - xx
// syy - @@y
// rrr - 
// szz - TCY
// tp  - G^Cv
void
addeffect(float xx, float yy, float sxx, float syy, float rrr, float szz, int tp)
{
	EFFECT* effect = pool_alloc(&effect_pool);
	InsertTailList(&effect_list, &effect->list_entry);

	effect->type = tp;
	effect->x = xx;
	effect->y = yy;
	effect->sx = sxx;
	effect->sy = syy;
	effect->rotate = rrr;
	effect->size = szz;
}

/****************************************************************************
 *	deleffect
 ****************************************************************************/

void
deleffect(EFFECT* effect)
{
	RemoveEntryList(&effect->list_entry);
	pool_free(effect);
}

/****************************************************************************
 *	addpertics
 ****************************************************************************/

// p[eBNĂƁ[ɔ΂(EFFECT_TYPE_PERTIC1_ɔ΂)
// xx  - Wx
// yy  - @@y
// spp - x(XJ[l)
// szz - TCY
// sxx - xx
// syy - @@y
// num - 
void
addpertics(float xx, float yy, float spp, float szz, float sxx, float syy, int numm)
{
	int i;
	float vx;
	float vy;
	float sz;

	for(i = 0; i < numm; i++) {
		vx = (rnd(64) - 32) / 32.0;
		vy = (rnd(64) - 32) / 32.0;
		sz =  rnd(64)       / 64.0;
		addeffect(
			xx,
			yy,
			vx * sz * spp + sxx,
			vy * sz * spp + syy,
			rnd(128) / 64.0 * M_PI,
			szz * (1.0 - sz * 0.8),
			EFFECT_TYPE_PERTIC1);
	}
}

/****************************************************************************
 *	destroypertics
 ****************************************************************************/

// GԂEƂ
// xx  - Wx
// yy  - @@y
// sxx - xx
// syy - @@y
// tp  - G^Cv
void
destroypertics(float xx, float yy, float sxx, float syy, int tp)
{
	int i;
	int t;
	float rr;

	if(tp < ENEMY_TYPE_ZAKO1) {
		// en
		addeffect(
			xx,
			yy,
			sxx,
			syy,
			rnd(128) / 64.0 * M_PI,
			32.0,
			EFFECT_TYPE_PERTIC1);
		addpertics(
			xx,
			yy,
			32.0,
			32.0,
			sxx,
			syy,
			3);
		ds_play(SND_EXPLODE0);
	} else {
		// UR/^
		addeffect(
			xx,
			yy,
			sxx,
			syy,
			rnd(128) / 64.0 * M_PI,
			64.0,
			EFFECT_TYPE_PERTIC1);
		addpertics(
			xx,
			yy,
			64.0,
			32.0,
			sxx,
			syy,
			15);

		if(tp < ENEMY_TYPE_BOX2) {
			// UR
			ds_play(SND_EXPLODE1);
		} else {
			// ^
			ds_play(SND_EXPLODE2);
			addeffect(
				xx,
				yy,
				sxx,
				syy,
				rnd(128) / 64.0 * M_PI,
				384.0,
				EFFECT_TYPE_RING);
			t = rnd(2) + 1;
			for(i = 0; i < t; i++) {
				rr = rnd(256) / 128.0 * M_PI;
				addeffect(
					xx + 192.0 * cos(rr),
					yy + 192.0 * sin(rr),
					sxx,
					syy,
					rr,
					128.0,
					EFFECT_TYPE_LINE);
			}
			// e
			REPEAT_ENEMY()
				if(enemy->type < ENEMY_TYPE_ZAKO1) {
					addeffect(
						enemy->x,
						enemy->y,
						(rnd(9) - 5) * 0.2,
						(rnd(3) - 5) * 0.2,
						0.0,
						0.0,
						EFFECT_TYPE_BANANA);
					banana_score++;
					delenemy(enemy);
				}
			LOOP_ENEMY()
		}
	}
}

/****************************************************************************
 *	addscore
 ****************************************************************************/

// XRAZ
// sscore - XRA
void
addscore(int sscore)
{
	score += sscore;
}

/****************************************************************************
 *	drawback
 ****************************************************************************/

void
drawback()
{
	memcpy(vbuff, bgbuff, DISP_X * DISP_Y);
}

/****************************************************************************
 *	drawstatus
 ****************************************************************************/

void
drawstatus()
{
	int retval;
	int i;
	int color;
	int param;
	int x;
	int y;
	int spr;
	int t;
	int tmp;

	for(i = 0; i < 2; i++) {
		color = i ? 2 : 0;
		param = DRW_CLR(color, COLOR_MASK);

		x = 1 - i;
		y = 1 - i;

		/* Ђ邢Ȃ */
		spr = SPR_HIRUINAKI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;

		/* E */
		render_point(&render, x + 1, y + 2, color);
		x += 3;

		/*  */
		spr = SPR_OYATUDAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", hiscore);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* / */
		retval = render_printf(&render, x, y, 2, color, "/");
		x += LOHALF(retval);

		/* ΂Ȃȑ */
		spr = SPR_BANANADAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", banana_hiscore);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);

		color = i ? 1 : 3;
		param = DRW_CLR(color, COLOR_MASK);

		x = 1 - i;
		y = DISP_Y - 11 - i;

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level / 10 + 1);
		x += LOHALF(retval);

		/*  */
		spr = SPR_CHOME;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ? */
		retval = render_printf(&render, x, y, 2, color, "%d", level % 10 + 1);
		x += LOHALF(retval);

		/* Ԓn */
		spr = SPR_BANTI;
		sprite_draw(x, y, spr, param);

		x = 1 - i;
		y = DISP_Y - 5 - i;

		/*  */
		spr = SPR_OYATUDAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", score);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* / */
		retval = render_printf(&render, x, y, 2, color, "/");
		x += LOHALF(retval);

		/* ΂Ȃȑ */
		spr = SPR_BANANADAI;
		sprite_draw(x, y, spr, param);
		x += sprite_table[spr].w;
		x += 1;

		/* ??? */
		retval = render_printf(&render, x, y, 2, color, "%d", banana_score);
		x += LOHALF(retval);

		/* ~ */
		spr = SPR_YEN;
		sprite_draw(x, y, spr, param);
	}

	t = 0;
	REPEAT_EFFECT()
		if(effect->type == EFFECT_TYPE_BANANA) t++;
	LOOP_EFFECT()
	if(t) {
		for(i = 0; i < 2; i++) {
			color = i ? (play_timer & 1) : 3;
			param = DRW_CLR(color, COLOR_MASK);

			x = DISP_X - 9 - i;
			y = DISP_Y - 5 - i;

			tmp = t; while(tmp >= 10) { tmp /= 10; x -= 4; }

			/* ??? */
			retval = render_printf(&render, x, y, 2, color, "%d", t);
			x += LOHALF(retval);

			/* ~ */
			spr = SPR_YEN;
			sprite_draw(x, y, spr, param);
		}
	}
}

/****************************************************************************
 *	debugstatus
 ****************************************************************************/

void
debugstatus()
{
	int x;
	int y;

	x = DISP_X - 25;
	y = DISP_Y - 21;
	render_printf_framed(&render, x, y, 2, 0x220, "ENE%3d", list_size((LIST*)&enemy_list));
	y += 7;
	render_printf_framed(&render, x, y, 2, 0x220, "THR%3d", list_size((LIST*)&threnemy_list));
	y += 7;
	render_printf_framed(&render, x, y, 2, 0x220, "EFF%3d", list_size((LIST*)&effect_list));
}

/****************************************************************************
 *	movemychar
 ****************************************************************************/

void
movemychar()
{
	float vx;
	float vy;
	float vr;

	// @֌W---------------------
	// Ct
	if(mychar.life < MYCHAR_LIFE_MAX) {
		mychar.life++;
	}

	// ړ
	vx = 0.0;
	vy = 0.0;
	if(joy & PAD_LF) { vx = -1.0; mychar.gr_rotate -= MYCHAR_ROT; }
	if(joy & PAD_UP) { vy = -1.0; mychar.gr_rotate -= MYCHAR_ROT; }
	if(joy & PAD_RI) { vx =  1.0; mychar.gr_rotate += MYCHAR_ROT; }
	if(joy & PAD_DN) { vy =  1.0; mychar.gr_rotate += MYCHAR_ROT; }
	if(vx || vy) {
		vr = sqrt(vx * vx + vy * vy);
		if(vr) {
			vx = vx / vr;
			vy = vy / vr;
		}
		if(((anchor.state == ANCHOR_STATE_STANDBY) || (anchor.state == ANCHOR_STATE_RETURN)) && !(joy & PAD_B)) {
			mychar.ssx += vx * MYCHAR_SPEED1;
			mychar.ssy += vy * MYCHAR_SPEED1;
		} else {
			mychar.ssx += vx * MYCHAR_SPEED2;
			mychar.ssy += vy * MYCHAR_SPEED2;
		}
	}

	// ƌ
	mychar.x += (mychar.sx + mychar.ssx);
	mychar.y += (mychar.sy + mychar.ssy);

	mychar.ssx *= MYCHAR_SPWEAKEN;
	mychar.ssy *= MYCHAR_SPWEAKEN;
	mychar.sx *= MYCHAR_REACTWEAKEN;
	mychar.sy *= MYCHAR_REACTWEAKEN;
	mychar.gr_rotate *= MYCHAR_ROTWEAKEN;

	if(mychar.x <         32.0) mychar.x =         32.0;
	if(mychar.x > 640.0 - 32.0) mychar.x = 640.0 - 32.0;
	if(mychar.y <         32.0) mychar.y =         32.0;
	if(mychar.y > 480.0 - 32.0) mychar.y = 480.0 - 32.0;

	// GƂ̃RW(Փ˔)-----------------------
	REPEAT_ENEMY()
		vx = mychar.x - enemy->x;
		vy = mychar.y - enemy->y;
		vr = MYCHAR_SIZE + enemy_spec[enemy->type].size;
		if(vx * vx + vy * vy < vr * vr) {
			// H
			if(mychar.dam_timer) {
				mychar.life -= enemy_spec[enemy->type].dam * MYCHAR_DAMAGE;
			} else {
				mychar.life -= enemy_spec[enemy->type].dam;
			}
			mychar.dam_timer = MYCHAR_DAM_TIME;
			//{{---
			//vr = sqrt(vx * vx + vy * vy);
			//̂悤ɌvẐƎv̂łA
			//̌vZ@ŃQ[oXĂ܂B
			vr = sqrt(vr);
			//}}---
			if(vr) {
				vx /= vr;
				vy /= vr;
			}
			mychar.sx = MYCHAR_DAM_SP * vx;
			mychar.sy = MYCHAR_DAM_SP * vy;

			if(anchor.state == ANCHOR_STATE_GRAB) {
				// ͂ł͓̂
				anchor.state = ANCHOR_STATE_RETURN;
				vx = anchor.sx / 2.0/* + ANCHOR_RELEASE_SP * cos(anchor.rotate)*/;	// ANCHOR_RELEASE_SP`Ȃ̂0.0ƌȂ(oO?)
				vy = anchor.sy / 2.0/* + ANCHOR_RELEASE_SP * sin(anchor.rotate)*/;	// ANCHOR_RELEASE_SP`Ȃ̂0.0ƌȂ(oO?)
				addthrenemy(
					grab_enemy.x,
					grab_enemy.y,
					vx,
					vy,
					grab_enemy.rotate,
					grab_enemy.type,
					grab_enemy.life);
			}

			// GɃ_[W
			enemy->life -= 5;
			if(enemy->life > 0) {
				vx = (enemy->x + mychar.x) / 2.0;
				vy = (enemy->y + mychar.y) / 2.0;
				addeffect(
					vx,
					vy,
					0.0,
					0.0,
					0.0,
					96.0,
					EFFECT_TYPE_PERTIC1);
				addpertics(
					vx,
					vy,
					64.0,
					32.0,
					0.0,
					0.0,
					15);
			} else {
				destroypertics(
					enemy->x,
					enemy->y,
					enemy->sx,
					enemy->sy,
					enemy->type);
				delenemy(enemy);
			}

			ds_play(SND_MISS);
			break; /* ܂ */
		}
	LOOP_ENEMY()
}

/****************************************************************************
 *	moveanchor
 ****************************************************************************/

void
moveanchor()
{
	float vx;
	float vy;
	float rr;
	float vxx;
	float vyy;

	if(anchor.x <   0.0) anchor.x =   0.0;
	if(anchor.x > 640.0) anchor.x = 640.0;
	if(anchor.y <   0.0) anchor.y =   0.0;
	if(anchor.y > 480.0) anchor.y = 480.0;

	// o[xNg(vx,vy)
	vx = 0.0;
	vy = 0.0;
	if(joy & PAD_LF) vx = -1.0;
	if(joy & PAD_UP) vy = -1.0;
	if(joy & PAD_RI) vx =  1.0;
	if(joy & PAD_DN) vy =  1.0;

	// X^oC
	if(anchor.state == ANCHOR_STATE_STANDBY) {
		// ړĂꍇ̓AJ[Ɍ
		if(vx || vy) {
			rr = atan2(vy, vx);
			if(fabs(mychar.anc_rotate - rr) > M_PI) {
				if(mychar.anc_rotate > rr) {
					mychar.anc_rotate -= M_PI2;
				} else {
					mychar.anc_rotate += M_PI2;
				}
			}
			mychar.anc_rotate = mychar.anc_rotate * (1.0 - ANCHOR_ROT_SP) + rr * ANCHOR_ROT_SP;
		}

		anchor.sx = 0.0;
		anchor.sy = 0.0;
		anchor.x = mychar.x + 40.0 * cos(mychar.anc_rotate);
		anchor.y = mychar.y + 40.0 * sin(mychar.anc_rotate);
		anchor.rotate = mychar.anc_rotate;

		// ˏo
		if(joy & TRG_A) {
			anchor.state = ANCHOR_STATE_THROW;
			anchor.sx = ANCHOR_SHOT_SP * cos(mychar.anc_rotate);
			anchor.sy = ANCHOR_SHOT_SP * sin(mychar.anc_rotate);

			mychar.sx = -anchor.sx * ANCHOR_REACT_FORCE;
			mychar.sy = -anchor.sy * ANCHOR_REACT_FORCE;

			ds_play(SND_ANCHOR_SHOT);
			return; /* ܂ */
		}
	}

	// 
	if(anchor.state == ANCHOR_STATE_THROW) {
		anchor.x += anchor.sx;
		anchor.y += anchor.sy;

		vxx = anchor.x - mychar.x;
		vyy = anchor.y - mychar.y;
		if(vx || vy) {
			anchor.sx += vx * ANCHOR_SHOT_CONTROL;
			anchor.sy += vy * ANCHOR_SHOT_CONTROL;
			rr = sqrt(anchor.sx * anchor.sx + anchor.sy * anchor.sy);
			if(rr) {
				anchor.sx = anchor.sx * ANCHOR_SHOT_SP / rr;
				anchor.sy = anchor.sy * ANCHOR_SHOT_SP / rr;
			}
			anchor.rotate = atan2(vyy, vxx);
		}

		if(!(joy & PAD_A) ||
		   (anchor.x > 640.0) || (anchor.x < 0.0) ||
		   (anchor.y > 480.0) || (anchor.y < 0.0) ||
		   (sqrt(vxx * vxx + vyy * vyy) > ANCHOR_LENGTH_LIMIT)) {
			anchor.state = ANCHOR_STATE_RETURN;
		}
	}

	// ͂ݏ
	if(anchor.state == ANCHOR_STATE_GRAB) {
		anchor.sx += ANCHOR_GRAB_SP * vx;
		anchor.sy += ANCHOR_GRAB_SP * vy;
		anchor.sx *= ANCHOR_GRAB_SPWEAKEN;
		anchor.sy *= ANCHOR_GRAB_SPWEAKEN;

		anchor.x += anchor.sx;
		anchor.y += anchor.sy;

		vxx = anchor.x - mychar.x;
		vyy = anchor.y - mychar.y;
		rr = sqrt(vxx * vxx + vyy * vyy);
		if(rr < 20.0) {
			if(rr) {
				anchor.x = mychar.x + 20.0 * vxx / rr;
				anchor.y = mychar.y + 20.0 * vyy / rr;
			}
			anchor.sx *= 0.8;
			anchor.sy *= 0.8;
		} else if(rr > ANCHOR_LENGTH_LIMIT) {
			anchor.x = mychar.x + ANCHOR_LENGTH_LIMIT * vxx / rr;
			anchor.y = mychar.y + ANCHOR_LENGTH_LIMIT * vyy / rr;
		}

		rr = anchor.rotate;
		anchor.rotate = atan2(vyy, vxx);
		grab_enemy.rotate += anchor.rotate - rr;
		while(grab_enemy.rotate >= M_PI) grab_enemy.rotate -= M_PI2;
		while(grab_enemy.rotate < -M_PI) grab_enemy.rotate += M_PI2;

		grab_enemy.x = anchor.x + (ANCHOR_SIZE + enemy_spec[grab_enemy.type].size) / 2.0 * cos(anchor.rotate);
		grab_enemy.y = anchor.y + (ANCHOR_SIZE + enemy_spec[grab_enemy.type].size) / 2.0 * sin(anchor.rotate);

		// 
		if(!(joy & PAD_A)) {
			anchor.state = ANCHOR_STATE_RETURN;

			vxx = anchor.sx + ANCHOR_THROW_SP * cos(anchor.rotate);
			vyy = anchor.sy + ANCHOR_THROW_SP * sin(anchor.rotate);

			addthrenemy(
				grab_enemy.x,
				grab_enemy.y,
				vxx,
				vyy,
				grab_enemy.rotate,
				grab_enemy.type,
				grab_enemy.life);

			ds_play(SND_ANCHOR_GRAB);
		}
	}

	// 
	if(anchor.state == ANCHOR_STATE_RETURN) {
		vxx = anchor.x - mychar.x;
		vyy = anchor.y - mychar.y;
		rr = sqrt(vxx * vxx + vyy * vyy);
		if(rr) {
			anchor.sx = -ANCHOR_RETURN_SP * vxx / rr;
			anchor.sy = -ANCHOR_RETURN_SP * vyy / rr;
		}
		anchor.rotate = atan2(vyy, vxx);

		anchor.x += anchor.sx;
		anchor.y += anchor.sy;

		if(rr < 32.0) {
			mychar.sx = anchor.sx * ANCHOR_REACT_FORCE;
			mychar.sy = anchor.sy * ANCHOR_REACT_FORCE;
			mychar.anc_rotate = atan2(vyy, vxx);
			anchor.state = ANCHOR_STATE_STANDBY;

			ds_play(SND_ANCHOR_RETURN);
		}
	}

	// AJ[ƓG̏Փ------------------------------
	REPEAT_ENEMY()
		vxx = anchor.x - enemy->x;
		vyy = anchor.y - enemy->y;
		rr = ANCHOR_SIZE + enemy_spec[enemy->type].size;
		if(vxx * vxx + vyy * vyy < rr * rr) {
			// G̗͂1Ȃ
			if(enemy->life < 1) {
				destroypertics(
					enemy->x,
					enemy->y,
					enemy->sx,
					enemy->sy,
					enemy->type);
				delenemy(enemy);
				continue; /* ܂ */
			}
			// ݂͂ɍs
			if(anchor.state == ANCHOR_STATE_THROW) {
				// GXRAœG̗͂ꍇ͎s
				if((enemy->life > CATCHABLE_BORDER) && enemy_spec[enemy->type].score) {
					enemy->life--; // Gɏ_[W
					anchor.state = ANCHOR_STATE_RETURN;
					addpertics(
						anchor.x - vxx / 2.0,
						anchor.y - vyy / 2.0,
						32.0,
						32.0,
						0.0,
						0.0,
						8);
					ds_play(SND_BLOCK);
					break; /* ܂ */
				}
				// AJ[H
				anchor.state = ANCHOR_STATE_GRAB;
				anchor.sx = enemy->sx / 2.0;
				anchor.sy = enemy->sy / 2.0;
				grab_enemy.type = enemy->type;
				grab_enemy.x = enemy->x;
				grab_enemy.y = enemy->y;
				grab_enemy.rotate = enemy->rotate;
				grab_enemy.life = enemy_spec[enemy->type].life; // enemy->life
				delenemy(enemy);
				ds_play(SND_ANCHOR_GRAB);
				break; /* ܂ */
			}
			if(anchor.state == ANCHOR_STATE_STANDBY) {
				// ͂
				addeffect(
					anchor.x - vxx / 2.0,
					anchor.y - vyy / 2.0,
					0.0,
					0.0,
					rnd(128) / 64.0 * M_PI,
					32.0,
					EFFECT_TYPE_PERTIC1);
				addpertics(
					anchor.x - vxx / 2.0,
					anchor.y - vyy / 2.0,
					32.0,
					32.0,
					0.0,
					0.0,
					3);
				//{{---
				//rr = sqrt(vxx * vxx + vyy * vyy);
				//̂悤ɌvẐƎv̂łA
				//̌vZ@ŃQ[oXĂ܂B
				rr = sqrt(rr);
				//}}---
				if(rr) {
					vxx /= rr;
					vyy /= rr;
				}
				mychar.sx = MYCHAR_DAM_SP * vxx;
				mychar.sy = MYCHAR_DAM_SP * vyy;
				ds_play(SND_BLOCK);
			}
		}
	LOOP_ENEMY()

	if(anchor.state == ANCHOR_STATE_THROW) {
		REPEAT_THRENEMY()
			vxx = anchor.x - threnemy->x;
			vyy = anchor.y - threnemy->y;
			rr = ANCHOR_SIZE + enemy_spec[threnemy->type].size;
			if(vxx * vxx + vyy * vyy < rr * rr) {
				// AJ[H
				anchor.state = ANCHOR_STATE_GRAB;
				anchor.sx = threnemy->sx / 2.0;
				anchor.sy = threnemy->sy / 2.0;
				grab_enemy.type = threnemy->type;
				grab_enemy.x = threnemy->x;
				grab_enemy.y = threnemy->y;
				grab_enemy.rotate = threnemy->rotate;
				grab_enemy.life = threnemy->life;
				delthrenemy(threnemy);
				ds_play(SND_ANCHOR_GRAB);
				break; /* ܂ */
			}
		LOOP_THRENEMY()
	}
}

/****************************************************************************
 *	moveenemy
 ****************************************************************************/

void
moveenemy()
{
	int i;
	int j;
	int t;
	int ty;
	float vx;
	float vy;
	float rr;
	float sp;
	float r;

	// ʏ
	REPEAT_ENEMY()
		// 폜
		if((enemy->x < -128.0) ||
		   (enemy->y < -128.0) || (enemy->y > 480.0 + 128.0)) {
			delenemy(enemy);
			continue; /* ܂ */
		}
		vx = mychar.x - enemy->x;
		vy = mychar.y - enemy->y;
		rr = atan2(vy, vx);
		switch(enemy->type) {
		// --------------------------------
		case ENEMY_TYPE_SHOT1:
		case ENEMY_TYPE_SHOT2:
			enemy->x += enemy->sx;
			enemy->y += enemy->sy;
			if((enemy->x < -32.0) || (enemy->x > 640.0 + 32.0) ||
			   (enemy->y < -32.0) || (enemy->y > 480.0 + 32.0)) {
				delenemy(enemy);
				continue; /* ܂ */
			}
			break;
		// |bL[卪-----------------------
		case ENEMY_TYPE_SHOT3:
		case ENEMY_TYPE_SHOT4:
			enemy->timer++;
			if(enemy->timer < 40) {
				enemy->rotate += 0.3;
				while(enemy->rotate >= M_PI) enemy->rotate -= M_PI2;
			} else {
				if(enemy->timer == 40) {
					enemy->rotate = rr;
				}
				sp = level * 0.006 + 0.2;
				enemy->sx += sp * cos(enemy->rotate);
				enemy->sy += sp * sin(enemy->rotate);
			}
			enemy->sx *= 0.95;
			enemy->sy *= 0.95;
			enemy->x += enemy->sx;
			enemy->y += enemy->sy;
			if((enemy->x < -32.0) || (enemy->x > 640.0 + 32.0) ||
			   (enemy->y < -32.0) || (enemy->y > 480.0 + 32.0)) {
				delenemy(enemy);
				continue; /* ܂ */
			}
			break;
		// Ȃ--------------------------------
		case ENEMY_TYPE_ZAKO1:
			enemy->timer++;
			if(enemy->timer < 60) {
				enemy->x += enemy->sx;
				enemy->y += enemy->sy;
				enemy->sx *= 0.95;
				enemy->sy *= 0.95;
			}
			if(enemy->timer == 60) {
				if((enemy->y < 120.0) || (enemy->y > 360.0)) {
					if(enemy->x < 320.0) {
						enemy->sx = 1.0;
						enemy->sy = 0.0;
					} else {
						enemy->sx = -1.0;
						enemy->sy =  0.0;
					}
				} else {
					if(enemy->y < 240.0) {
						enemy->sx = 0.0;
						enemy->sy = 1.0;
					} else {
						enemy->sx =  0.0;
						enemy->sy = -1.0;
					}
				}
			}
			if((enemy->timer > 60) & (enemy->timer < 310)) {
				enemy->x += enemy->sx;
				enemy->y += enemy->sy;
				enemy->x += sin(enemy->timer * 0.1);
				enemy->y += cos(enemy->timer * 0.1);
				if(enemy->timer > 310 - level * 2) {
					enemy->rotate += 0.1;
					while(enemy->rotate >= M_PI) enemy->rotate -= M_PI2;
					if(!(enemy->timer % 10)) {
						rr = rnd(16) / 8.0 * M_PI;
						addenemy(
							enemy->x,
							enemy->y,
							4.0 * cos(rr),
							4.0 * sin(rr),
							rr,
							ENEMY_TYPE_SHOT1);
					}
				}
			}
			if(enemy->timer > 309) {
				vx = enemy->x - 320.0;
				vy = enemy->y - 240.0;
				rr = sqrt(vx * vx + vy * vy);
				enemy->sx = (vx / rr) * (enemy->timer - 310) * 0.1;
				enemy->sy = (vy / rr) * (enemy->timer - 310) * 0.1;
				enemy->x += enemy->sx;
				enemy->y += enemy->sy;
			}
			break;
		// Ă-----------------------------------
		case ENEMY_TYPE_ZAKO2:
			enemy->timer++;
			if(!(enemy->timer % 120)) {
				vx = mychar.x - enemy->x;
				vy = mychar.y - enemy->y;
				rr = sqrt(vx * vx + vy * vy);
				enemy->sx = (vx / rr) * (level + 48) / 12.0;
				enemy->sy = (vy / rr) * (level + 48) / 12.0;
			} else {
				rr = (enemy->timer % 120) / 120.0;
				enemy->x += enemy->sx;
				enemy->y += enemy->sy;
				enemy->sx *= 0.95;
				enemy->sy *= 0.95;
				enemy->rotate += (rr * rr);
				while(enemy->rotate >= M_PI) enemy->rotate -= M_PI2;
			}
			break;
		// ---------------------------------------
		case ENEMY_TYPE_BOX1:
		case ENEMY_TYPE_BOX2:
			enemy->x += enemy->sx;
			enemy->y += enemy->sy;
			break;
		// ---------------------------------------
		case ENEMY_TYPE_MID1:
			enemy->timer++;
			if(enemy->timer < 60) {
				enemy->x += enemy->sx;
				enemy->y += enemy->sy;
				enemy->sx *= 0.95;
				enemy->sy *= 0.95;
				enemy->flag = rnd(8);
			}
			if(enemy->timer > 59) {
				enemy->sx = 0.0;
				enemy->sy = 0.0;
				enemy->x += sin(enemy->timer * 0.05) * 0.25;
				enemy->y += cos(enemy->timer * 0.05) * 0.25;
				if(enemy->x <         32.0) enemy->x += 0.5;
				if(enemy->x > 640.0 - 32.0) enemy->x -= 0.5;
				if(enemy->y <         32.0) enemy->y += 0.5;
				if(enemy->y > 480.0 - 32.0) enemy->y -= 0.5;
			}
			if(!(enemy->timer % 30)) {
				enemy->flag++;
				if(!(enemy->flag % 8)) { // 4way
					t = level / 8 + 1;
					for(i = 0; i < t; i++) {
						if(level < 20) {
							sp = i * 0.7 + 2.8 - 0.1 * level;
						} else {
							sp = i * 0.7 + 0.8;
						}
						addenemy(enemy->x, enemy->y, sp * cos(rr + M_PI * 0.40), sp * sin(rr + M_PI * 0.40), 0.0, ENEMY_TYPE_SHOT1);
						addenemy(enemy->x, enemy->y, sp * cos(rr + M_PI * 0.15), sp * sin(rr + M_PI * 0.15), 0.0, ENEMY_TYPE_SHOT1);
						addenemy(enemy->x, enemy->y, sp * cos(rr - M_PI * 0.15), sp * sin(rr - M_PI * 0.15), 0.0, ENEMY_TYPE_SHOT1);
						addenemy(enemy->x, enemy->y, sp * cos(rr - M_PI * 0.40), sp * sin(rr - M_PI * 0.40), 0.0, ENEMY_TYPE_SHOT1);
					}
					ds_play(SND_ENEMYSHOT);
				}
				if((enemy->flag % 8) == 4) { // ɂ񂶂Vbg
					sp = 6.0 + level * 0.06;
					addenemy(
						enemy->x,
						enemy->y,
						sp * cos(rr),
						sp * sin(rr),
						rr,
						ENEMY_TYPE_SHOT2);
					t = level / 10;
					for(i = 0; i < t; i++) {
						r = M_PI / 36.0 * (i + 1);
						sp *= 0.8;
						addenemy(enemy->x, enemy->y, sp * cos(rr + r), sp * sin(rr + r), 0.0, ENEMY_TYPE_SHOT1);
						addenemy(enemy->x, enemy->y, sp * cos(rr - r), sp * sin(rr - r), 0.0, ENEMY_TYPE_SHOT1);
					}
					ds_play(SND_ENEMYSHOT);
				}
			}
			break;
		// v---------------------------------------
		case ENEMY_TYPE_MID2:
			enemy->timer++;
			if(enemy->timer == 1) {
				enemy->flag = rnd(8);
			};
			if(!(enemy->timer % 120)) {
				sp = 4.0 + level * 0.1;
				rr = rnd(16) / 8.0 * M_PI;
				enemy->sx = sp * cos(rr);
				enemy->sy = sp * sin(rr);
			} else {
				if((enemy->x <         32.0) && (enemy->sx < 0.0)) enemy->sx *= -0.8;
				if((enemy->x > 640.0 - 32.0) && (enemy->sx > 0.0)) enemy->sx *= -0.8;
				if((enemy->y <         32.0) && (enemy->sy < 0.0)) enemy->sy *= -0.8;
				if((enemy->y > 480.0 - 32.0) && (enemy->sy > 0.0)) enemy->sy *= -0.8;
				enemy->x += enemy->sx;
				enemy->y += enemy->sy;
				enemy->sx *= 0.95;
				enemy->sy *= 0.95;
			}
			if(!(enemy->timer % 30)) {
				enemy->flag++;
				if(!(enemy->flag % 8)) { // 8΂T
					vx = enemy->x;
					vy = enemy->y;
					t = level / 7 + 1;
					for(i = 0; i < t; i++) {
						if(level < 20) {
							sp = i * 0.6 + 2.8 - 0.1 * level;
						} else {
							sp = i * 0.6 + 0.8;
						}
						if(i == (level / 7)) {
							ty = ENEMY_TYPE_SHOT2;
						} else {
							ty = ENEMY_TYPE_SHOT1;
						}
						for(j = 0; j < 8; j++) {
							rr = M_PI / 4.0 * j;
							if(!(j & 1) || (ty == ENEMY_TYPE_SHOT1)) {
								addenemy(
									vx,
									vy,
									sp * cos(rr),
									sp * sin(rr),
									rr,
									ty);
							}
						}
					}
					ds_play(SND_ENEMYSHOT);
				}
			}
			if(!(enemy->timer % 3) && ((enemy->timer % 60) < (level / 5 + 1))) {
				if((enemy->flag % 8) == 4) { // 卪݂[
					sp = 8.0 + level * 0.08;
					rr = rnd(32) / 16.0 * M_PI;
					addenemy(
						enemy->x,
						enemy->y,
						sp * cos(rr),
						sp * sin(rr),
						rr,
						ENEMY_TYPE_SHOT4);
					ds_play(SND_ENEMYSHOT);
				}
			}
			break;
		}
	LOOP_ENEMY()

	// 
	REPEAT_THRENEMY()
		// j
		if((threnemy->x < 0.0) || (threnemy->x > 640.0) ||
		   (threnemy->y < 0.0) || (threnemy->y > 480.0)) {
			destroypertics(
				threnemy->x,
				threnemy->y,
				0.0,
				0.0,
				threnemy->type);
			addscore(enemy_spec[threnemy->type].score);
			delthrenemy(threnemy);
			continue; /* ܂ */
		}
		threnemy->x += threnemy->sx;
		threnemy->y += threnemy->sy;
		threnemy->rotate += 0.05;
		threnemy->sy += THROWN_DROP_SP;
	LOOP_THRENEMY()
}

/****************************************************************************
 *	collisionenemy
 ****************************************************************************/

void
collisionenemy()
{
	float vx;
	float vy;
	float rr;
	float ss;
	float tt;

	REPEAT_ENEMY()
		// ͂ݓG-----------------------------
		if(anchor.state == ANCHOR_STATE_GRAB) {
			vx = grab_enemy.x - enemy->x;
			vy = grab_enemy.y - enemy->y;
			rr = enemy_spec[grab_enemy.type].size + enemy_spec[enemy->type].size; // Kvȋ
			ss = vx * vx + vy * vy; // ۂ̋^2
			if(ss < rr * rr) {
				ss = sqrt(ss); // ۂ̋
				//{{---
				//if(ss) {
				//	tt = (rr - ss) / ss / 2.0;
				//̂悤ɌvẐƎv̂łA
				//̌vZ@ŃQ[oXĂ܂B
				{
					tt = (rr - ss) / rr / 2.0;
				//}}---
					vx *= tt;
					vy *= tt;
				}
				// ڐG
				grab_enemy.x += vx;
				grab_enemy.y += vy;
				enemy->x -= vx;
				enemy->y -= vy;
				addpertics(
					(grab_enemy.x + enemy->x) / 2.0,
					(grab_enemy.y + enemy->y) / 2.0,
					32.0,
					32.0,
					0.0,
					0.0,
					1);
				enemy->life-- ;
				grab_enemy.life--;
				if(enemy->life < 0) {
					grab_enemy.life++;
				} else {
					anchor.sx *= GRAB_HIT_WEAKEN;
					anchor.sy *= GRAB_HIT_WEAKEN;
				}
				// j
				if(grab_enemy.life < 1) {
					anchor.state = ANCHOR_STATE_RETURN;
					destroypertics(
						grab_enemy.x,
						grab_enemy.y,
						anchor.sx,
						anchor.sy,
						grab_enemy.type);
					addscore(enemy_spec[grab_enemy.type].score);
				}
				if(enemy->life < 1) {
					destroypertics(
						enemy->x,
						enemy->y,
						enemy->sx,
						enemy->sy,
						enemy->type);
					addscore(enemy_spec[enemy->type].score);
					delenemy(enemy);
					goto L_NEXT; /* ܂ */
				}
				ds_play(SND_DAMAGE);
			}
		}

		// G--------------------------
		REPEAT_THRENEMY()
			vx = threnemy->x - enemy->x;
			vy = threnemy->y - enemy->y;
			rr = enemy_spec[threnemy->type].size + enemy_spec[enemy->type].size; // Kvȋ
			ss = vx * vx + vy * vy; // ۂ̋^2
			if(ss < rr * rr) {
				ss = sqrt(ss); // ۂ̋
				//{{---
				//if(ss) {
				//	tt = (rr - ss) / ss / 2.0;
				//̂悤ɌvẐƎv̂łA
				//̌vZ@ŃQ[oXĂ܂B
				{
					tt = (rr - ss) / rr / 2.0;
				//}}---
					vx *= tt;
					vy *= tt;
				}
				// ڐG
				threnemy->x += vx;
				threnemy->y += vy;
				enemy->x -= vx;
				enemy->y -= vy;
				addpertics(
					(threnemy->x + enemy->x) / 2.0,
					(threnemy->y + enemy->y) / 2.0,
					32.0,
					32.0,
					0.0,
					0.0,
					1);
				threnemy->life--;
				enemy->life -= 2; // G͓{_[W
				if(enemy->life < 0) {
					threnemy->life++;
				}
				threnemy->sx *= THROWN_HIT_WEAKEN;
				threnemy->sy *= THROWN_HIT_WEAKEN;
				// j
				if(threnemy->life < 1) {
					destroypertics(
						threnemy->x,
						threnemy->y,
						threnemy->sx,
						threnemy->sy,
						threnemy->type);
					addscore(enemy_spec[threnemy->type].score);
					delthrenemy(threnemy);
				}
				if(enemy->life < 1) {
					destroypertics(
						enemy->x,
						enemy->y,
						enemy->sx,
						enemy->sy,
						enemy->type);
					addscore(enemy_spec[enemy->type].score);
					delenemy(enemy);
					goto L_NEXT; /* ܂ */
				}
				ds_play(SND_DAMAGE);
			}
		LOOP_THRENEMY()
L_NEXT:
	LOOP_ENEMY()
}

/****************************************************************************
 *	geneenemy
 ****************************************************************************/

void
geneenemy()
{
	int t;
	float rr;
	float vx;
	float vy;
	float xxx;
	float yyy;
	float dx;
	float dy;

	// UR
	t = 0;
	REPEAT_ENEMY()
		if(enemy->type > ENEMY_TYPE_SHOT4) t++;	// GeȊOJEg
	LOOP_ENEMY()
	//
	if((!(play_timer % (30 + (level % 5) * 12)) && ((level % 10    ) > 4)) ||
	   (!(play_timer % (20                   )) && ((level / 10 + 2) > t))) {
		rr = rnd(64) / 32.0 * M_PI;
		vx = sin(rr);
		vy = cos(rr);
		xxx = 320.0 - 352.0 * vx;
		yyy = 240.0 - 352.0 * vy;
		vx *= 6.0;
		vy *= 6.0;
		//
		dx = mychar.x - xxx;
		dy = mychar.y - yyy;
		rr = sqrt(dx * dx + dy * dy);
		if(rr > ENEMYGENE_NONECRASH) {
			if((level % 4) < 2) {
				addenemy(xxx, yyy, vx, vy, 0.0, ENEMY_TYPE_ZAKO1);
			} else {
				addenemy(xxx, yyy, vx, vy, 0.0, ENEMY_TYPE_ZAKO2);
			}
		}
	}

	// 
	if(!(play_timer % 60) && !rnd(8)) {
		if(!rnd(5)) {
			addenemy(  0.0 - 32.0,   0.0 + 32.0,  4.0, 0.0, 0.0, ENEMY_TYPE_BOX2);
		} else {
			addenemy(640.0 + 32.0, 480.0 - 32.0, -2.0, 0.0, 0.0, ENEMY_TYPE_BOX1);
		}
	}

	// ^
	if(!(play_timer % (295 - (level % 5) * 40)) && ((level % 5) > 1)) {
		t = 0;
		REPEAT_ENEMY()
			if((enemy->type == ENEMY_TYPE_MID1) || (enemy->type == ENEMY_TYPE_MID2)) t++;	// ^JEg
		LOOP_ENEMY()
		//
		if(t < ((level + 6) / 10)) {
			rr = rnd(64) / 32.0 * M_PI;
			vx = sin(rr);
			vy = cos(rr);
			xxx = 320.0 - 352.0 * vx;
			yyy = 240.0 - 352.0 * vy;
			vx *= 8.0;
			vy *= 8.0;
			//
			dx = mychar.x - xxx;
			dy = mychar.y - yyy;
			rr = sqrt(dx * dx + dy * dy);
			if(rr > ENEMYGENE_NONECRASH) {
				if((level < 6) || !rnd(2)) {
					addenemy(xxx, yyy, vx, vy, 0.0, ENEMY_TYPE_MID1);
				} else {
					addenemy(xxx, yyy, vx, vy, 0.0, ENEMY_TYPE_MID2);
				}
			}
		}
	}
}

/****************************************************************************
 *	fdrawenemy
 ****************************************************************************/

void
fdrawenemy(float xx, float yy, float rot, int tp)
{
	switch(tp) {
	case ENEMY_TYPE_SHOT1: gcopy  (SPR_SHOT1,    xx, yy     ); break; // e
	case ENEMY_TYPE_SHOT2: grotate(SPR_SHOT2_00, xx, yy, rot); break; // jW
	case ENEMY_TYPE_SHOT3: grotate(SPR_SHOT3_00, xx, yy, rot); break; // |bL[
	case ENEMY_TYPE_SHOT4: grotate(SPR_SHOT4_00, xx, yy, rot); break; // 卪
	case ENEMY_TYPE_ZAKO1: grotate(SPR_ZAKO1_00, xx, yy, rot); break; // Ȃ
	case ENEMY_TYPE_ZAKO2: grotate(SPR_ZAKO2_00, xx, yy, rot); break; // Ă
	case ENEMY_TYPE_BOX1:  grotate(SPR_BOX1_00,  xx, yy, rot); break; // 5
	case ENEMY_TYPE_BOX2:  grotate(SPR_BOX2_00,  xx, yy, rot); break; // X
	case ENEMY_TYPE_MID1:  grotate(SPR_MID1_00,  xx, yy, rot); break; // 
	case ENEMY_TYPE_MID2:  grotate(SPR_MID2_00,  xx, yy, rot); break; // v
	}
}

/****************************************************************************
 *	drawmychar
 ****************************************************************************/

void
drawmychar()
{
	int spr;

	// ͂łG
	if(anchor.state == ANCHOR_STATE_GRAB) {
		fdrawenemy(
			grab_enemy.x,
			grab_enemy.y,
			grab_enemy.rotate,
			grab_enemy.type);
	}

	// AJ[
	if((anchor.state == ANCHOR_STATE_THROW) || (anchor.state == ANCHOR_STATE_RETURN)) {
		spr = SPR_ANCHOR2_00;
	} else {
		spr = SPR_ANCHOR1_00;
	}
	grotate(spr,
		anchor.x,
		anchor.y,
		anchor.rotate);

	// @
	if(mychar.dam_timer || ((mychar.life < MYCHAR_LIFE_BRINK) && (play_timer % 10 < 5))) {
		if(mychar.dam_timer) mychar.dam_timer--;
		spr = SPR_MYCHAR3_00;
	} else {
		if((play_timer / 6) & 1) {
			spr = SPR_MYCHAR2_00;
		} else {
			spr = SPR_MYCHAR1_00;
		}
	}
	grotate(spr,
		mychar.x,
		mychar.y,
		mychar.gr_rotate);

	// @Ct
	if(mychar.life < MYCHAR_LIFE_MAX) {
		int x = mychar.x * (128.0 / 640.0) - 4;
		int y = mychar.y * ( 88.0 / 480.0) - 8;
		int n = (11 * mychar.life + (MYCHAR_LIFE_MAX - 1)) / MYCHAR_LIFE_MAX;
		render_rectangle_fill(&render, x - 1, y - 1, 11 + 2, 3, 3);
		render_rectangle_fill(&render, x    , y    ,      n, 1, 0);
		render_rectangle_fill(&render, x + n, y    , 11 - n, 1, 2);
	}
}

/****************************************************************************
 *	drawchain
 ****************************************************************************/

void
drawchain()
{
	int i;
	float vx;
	float vy;

	// AJ[`F[
	vx = mychar.x - anchor.x;
	vy = mychar.y - anchor.y;
	for(i = 0; i < ANCHOR_CHAIN_NUM; i++) {
		gcopy(
			SPR_CHAIN,
			mychar.x - vx * i / ANCHOR_CHAIN_NUM,
			mychar.y - vy * i / ANCHOR_CHAIN_NUM);
	}
}

/****************************************************************************
 *	drawenemy
 ****************************************************************************/

void
drawenemy()
{
	REPEAT_ENEMY()
		// ͂߂ȂGɂ̓Ot(̗͈ȏ&XRAt)
		if((enemy->life > CATCHABLE_BORDER) && enemy_spec[enemy->type].score) {
			int x = enemy->x * (128.0 / 640.0);
			int y = enemy->y * ( 88.0 / 480.0);
			int color = abs(play_timer / 4/**/ % 6 - 3); /* 3,2,1,0,1,2 */
			sprite_draw(x, y, SPR_CIRCLE, DRW_CLR(color, COLOR_MASK));
		}
		fdrawenemy(
			enemy->x,
			enemy->y,
			enemy->rotate,
			enemy->type);
	LOOP_ENEMY()

	REPEAT_THRENEMY()
		fdrawenemy(
			threnemy->x,
			threnemy->y,
			threnemy->rotate,
			threnemy->type);
	LOOP_THRENEMY()
}

/****************************************************************************
 *	drawbanana
 ****************************************************************************/

void
drawbanana()
{
	REPEAT_EFFECT()
		if((effect->type == EFFECT_TYPE_BANANA) &&
		  ((effect->timer < EFFECT_LIVETIME / 2) || !(effect->timer & 1))) {
			gcopy(
				(effect->timer & 2) ? SPR_BANANA2 : SPR_BANANA1,
				effect->x,
				effect->y);
			effect->sy += THROWN_DROP_SP;
		}
	LOOP_EFFECT()
}

/****************************************************************************
 *	movedraweffect
 ****************************************************************************/

void
movedraweffect()
{
	static const unsigned char clr_tbl[4/*alpha*/][4/*now&3*/] = {
		{ 3,4,3,4 },
		{ 2,4,2,4 },
		{ 1,3,1,3 },
		{ 0,2,0,2 },
	};
	//
	int i;
	int x;
	int y;
	int spr;
	int color;
	float sz;

	REPEAT_EFFECT()
		i = 256 * (EFFECT_LIVETIME - effect->timer) / EFFECT_LIVETIME;
		if(effect->type == EFFECT_TYPE_LINE) i -= 128;
		i /= 64;
		if(i < 0) goto L_NEXT;
		if(i > 3) i = 3;
		color = clr_tbl[i][now & 3];
		if(color > 3) goto L_NEXT;

		switch(effect->type) {
		case EFFECT_TYPE_LINE:
			i = (effect->rotate + (M_PI2 / 32 / 2)) * (32 / M_PI2);
			while(i <   0             ) i += 16/*EFF30`3F*/;
			while(i >= 16/*EFF30`3F*/) i -= 16/*EFF30`3F*/;
			spr = SPR_EFF30_04 + i * 16/*EFF3x_04`64*/;
			break;
		//case EFFECT_TYPE_PERTIC1:
		//case EFFECT_TYPE_PERTIC2:
		//case EFFECT_TYPE_RING:
		default:
			if(effect->type == EFFECT_TYPE_RING) {
				spr = SPR_EFF2_02;
			} else {
				spr = SPR_EFF1_02;
			}
			break;
		}

		switch(effect->type) {
		case EFFECT_TYPE_PERTIC1:
		case EFFECT_TYPE_LINE:
			sz = (EFFECT_LIVETIME - effect->timer + 5) / (float)EFFECT_LIVETIME;
			sz = effect->size * sz * sz;
			if(effect->type == EFFECT_TYPE_LINE) sz *= 2.0;
			break;
		//case EFFECT_TYPE_PERTIC2:
		//case EFFECT_TYPE_RING:
		default:
			sz = (EFFECT_LIVETIME - effect->timer) / (float)EFFECT_LIVETIME;
			sz = effect->size * (1.0 - sz * sz);
			break;
		}
		sz = fabs(sz * (128.0 / 640.0));
		switch(effect->type) {
		case EFFECT_TYPE_LINE:
			for(i = 0; i < 16 - 1; i++) {
				sz -= 4.0;
				if(sz <= 0.0) break;
			}
			break;
		//case EFFECT_TYPE_PERTIC1:
		//case EFFECT_TYPE_PERTIC2:
		//case EFFECT_TYPE_RING:
		default:
			for(i = 0; i < 32 - 1; i++) {
				sz -= 2.0;
				if(sz <= 0.0) break;
			}
			break;
		}
		spr += i;

		x = effect->x * (128.0 / 640.0);
		y = effect->y * ( 88.0 / 480.0);
		sprite_draw(x, y, spr, DRW_CLR(color, COLOR_MASK));

L_NEXT:
		effect->x += effect->sx;
		effect->y += effect->sy;
		effect->sx *= EFFECT_SPWEAKEN;
		effect->sy *= EFFECT_SPWEAKEN;

		effect->timer++;
		if(effect->timer > EFFECT_LIVETIME) {
			deleffect(effect);
		}
	LOOP_EFFECT()
}
